SystemOrganization addCategory: #'Spec-Layout'!

Object subclass: #AbstractSpecLayoutAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!AbstractSpecLayoutAction commentStamp: '<historical>' prior: 0!
AbstractSpecLayoutAction is an abstract class representing a spec layout action.!

!AbstractSpecLayoutAction methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/18/2012 04:47'!
asSpecElements

	self subclassResponsibility ! !

!AbstractSpecLayoutAction methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 15:10'!
generateArguments

	! !

AbstractSpecLayoutAction subclass: #SpecLayoutSend
	instanceVariableNames: 'arguments selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutSend commentStamp: '<historical>' prior: 0!
A SpecLayoutSend is a spec layout action used when a selector is sent to the layout!

SpecLayoutSend subclass: #SpecLayoutAdd
	instanceVariableNames: 'layoutFrame subwidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutAdd commentStamp: '<historical>' prior: 0!
A SpecLayoutAdd represents the action to add a subwidget into a spec layout!

!SpecLayoutAdd class methodsFor: 'instance creation' stamp: 'StephaneDucasse 12/24/2012 17:17'!
subwidget: subwidget layoutFrame: aLayoutFrame

	^ self new
		subwidget: subwidget 
		layoutFrame: aLayoutFrame asLayoutFrame; 
		yourself! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:21'!
bottomFraction

	^ layoutFrame bottomFraction! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:23'!
bottomFraction: aNumber

	layoutFrame bottomFraction: aNumber ! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:21'!
bottomOffset

	^ layoutFrame bottomOffset ! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:23'!
bottomOffset: aNumber

	layoutFrame bottomOffset: aNumber! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'StephaneDucasse 12/27/2012 22:45'!
fractions
	^ layoutFrame fractionRectangle! !

!SpecLayoutAdd methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/15/2013 11:32'!
generateArguments
	
	self arguments: {{subwidget .#layout:. layoutFrame generateSpec}}.! !

!SpecLayoutAdd methodsFor: 'initialize' stamp: 'MarcusDenker 1/10/2013 14:48'!
initialize
	"Initialization code for SpecLayoutAdd"

	super initialize.
	self selector: #add:.
	layoutFrame := LayoutFrame identity.
	subwidget := nil.! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'StephaneDucasse 12/24/2012 18:40'!
layoutFrame

	^ layoutFrame! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'StephaneDucasse 12/24/2012 18:52'!
layoutFrame: newFrame

	layoutFrame := newFrame asLayoutFrame! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:23'!
leftFraction

	^ layoutFrame leftFraction ! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:23'!
leftFraction: aNumber

	layoutFrame leftFraction: aNumber
! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:23'!
leftOffset

	^ layoutFrame leftOffset! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:24'!
leftOffset: aNumber

	^ layoutFrame leftOffset: aNumber! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'StephaneDucasse 12/24/2012 18:31'!
offsets
	"to deprecate 
	"
	self flag: #fix.
	^ layoutFrame leftOffset  @ layoutFrame topOffset corner:  layoutFrame rightOffset  @ layoutFrame bottomOffset ! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:24'!
rightFraction

	^ layoutFrame rightFraction! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:24'!
rightFraction: aNumber

	^ layoutFrame rightFraction: aNumber! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:24'!
rightOffset

	^ layoutFrame rightOffset! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:24'!
rightOffset: aNumber

	layoutFrame rightOffset: aNumber! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
subwidget
	^ subwidget! !

!SpecLayoutAdd methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:31'!
subwidget: anObject
	subwidget := anObject! !

!SpecLayoutAdd methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 05:36'!
subwidget: aSpec fractions: frac offsets: off

	subwidget := aSpec isSymbol
				ifTrue: [{#model. aSpec}]
				ifFalse: [
					aSpec isCollection
						ifTrue: [
							aSpec isEmpty 
								ifTrue: [ "should raise an error" ]
								ifFalse: [ aSpec first == #model 
											ifTrue: [ aSpec ]
											ifFalse: [ {#model}, aSpec ]]]
						ifFalse: [ 
							"Not a symbol or a collection. We assume it's an object to add directly (like a morph by example)"
							aSpec ]].
	self fractions: frac.
	self offsets: off.
	
	self generateArguments! !

!SpecLayoutAdd methodsFor: 'instance creation' stamp: 'StephaneDucasse 12/24/2012 17:19'!
subwidget: aSpec layoutFrame: aLayoutFrame
	
	subwidget := aSpec isSymbol
				ifTrue: [{#model. aSpec}]
				ifFalse: [
					aSpec isCollection
						ifTrue: [
							aSpec isEmpty 
								ifTrue: [ "should raise an error" ]
								ifFalse: [ aSpec first == #model 
											ifTrue: [ aSpec ]
											ifFalse: [ {#model}, aSpec ]]]
						ifFalse: [ 
							"Not a symbol or a collection. We assume it's an object to add directly (like a morph by example)"
							aSpec ]].
	
	layoutFrame := aLayoutFrame.
	self generateArguments! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:24'!
topFraction

	^ layoutFrame topFraction! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:25'!
topFraction: aNumber

	layoutFrame topFraction: aNumber! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:25'!
topOffset

	^ layoutFrame topOffset! !

!SpecLayoutAdd methodsFor: 'protocol' stamp: 'StephaneDucasse 12/24/2012 17:25'!
topOffset: aNumber

	layoutFrame topOffset: aNumber! !

SpecLayoutAdd subclass: #SpecLayoutAddColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutAddColumn commentStamp: '<historical>' prior: 0!
A SpecLayoutAddColumn is an action representing the addition of a column to a layout!

!SpecLayoutAddColumn class methodsFor: 'instance creation' stamp: 'StephaneDucasse 12/27/2012 17:51'!
block: aBlock layoutFrame: aLayoutFrame

	^ self new
			block: aBlock 
			layoutFrame: aLayoutFrame;
			yourself! !

!SpecLayoutAddColumn methodsFor: 'instance creation' stamp: 'StephaneDucasse 12/27/2012 17:51'!
block: aBlock layoutFrame: aLayoutFrame

	| row |
	row := SpecColumnLayout composed.
	aBlock value: row.
	subwidget := row asArray.
	self layoutFrame: aLayoutFrame.
	self generateArguments! !

SpecLayoutAdd subclass: #SpecLayoutAddRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutAddRow commentStamp: '<historical>' prior: 0!
A SpecLayoutAddRow is an action representing the addition of a row to a layout
!

!SpecLayoutAddRow class methodsFor: 'instance creation' stamp: 'StephaneDucasse 12/27/2012 17:48'!
block: aBlock layoutFrame: aLayoutFrame

	^ self new
			block: aBlock 
			layoutFrame: aLayoutFrame;
			yourself! !

!SpecLayoutAddRow methodsFor: 'instance creation' stamp: 'StephaneDucasse 12/27/2012 17:48'!
block: aBlock layoutFrame: aLayoutFrame

	| row |
	row := SpecRowLayout composed.
	aBlock value: row.
	subwidget := row asArray.
	self layoutFrame: aLayoutFrame.
	self generateArguments! !

SpecLayoutAdd subclass: #SpecSplitterHorizontal
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecSplitterHorizontal commentStamp: '<historical>' prior: 0!
A SpecSplitterHorizontal is a description of the addition of a horizontal splitter!

!SpecSplitterHorizontal class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/31/2012 15:11'!
commands: commands

	^ self new
		commands: commands;
		yourself! !

!SpecSplitterHorizontal methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/31/2012 15:11'!
commands
	
	^ commands! !

!SpecSplitterHorizontal methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/31/2012 15:11'!
commands: anObject
	
	commands := anObject! !

!SpecSplitterHorizontal methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 17:11'!
generateArguments
	| index |

	index := self commands identityIndexOf: self.

	self arguments: { index }! !

!SpecSplitterHorizontal methodsFor: 'initialize' stamp: 'StephaneDucasse 12/27/2012 18:02'!
initialize
	"Initialization code for SpecSplitterHorizontal"

	super initialize.

	selector := #newHSplitterAt:.
	layoutFrame  := (0@0 corner: 0@0) asLayoutFrame 
							bottomOffset: 1.
	commands := nil.! !

!SpecSplitterHorizontal methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/31/2012 15:38'!
isSplitter

	^ true! !

SpecLayoutAdd subclass: #SpecSplitterVertical
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecSplitterVertical commentStamp: '<historical>' prior: 0!
A SpecSplitterVertical is the description of the addition of a vertical splitter!

!SpecSplitterVertical class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
commands: commands

	^ self new
		commands: commands;
		yourself! !

!SpecSplitterVertical methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
commands
	
	^ commands! !

!SpecSplitterVertical methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
commands: anObject
	
	commands := anObject! !

!SpecSplitterVertical methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
generateArguments
	| index |

	index := self commands identityIndexOf: self.

	self arguments: { index }! !

!SpecSplitterVertical methodsFor: 'initialize' stamp: 'StephaneDucasse 12/27/2012 18:02'!
initialize
	"Initialization code for SpecSplitterHorizontal"

	super initialize.

	selector := #newVSplitterAt:.
	layoutFrame := ((0@0 corner: 0@0) asLayoutFrame 
							rightOffset: 1).
	commands := nil.! !

!SpecSplitterVertical methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/31/2012 16:05'!
isSplitter

	^ true! !

SpecLayoutSend subclass: #SpecLayoutAddWithSpec
	instanceVariableNames: 'layoutFrame subwidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayoutAddWithSpec commentStamp: '<historical>' prior: 0!
A SpecLayoutAddWithSpec is an action representing an add in the spec layout with a spec selector precised!

!SpecLayoutAddWithSpec class methodsFor: 'instance creation' stamp: 'StephaneDucasse 12/27/2012 18:36'!
subwidget: subwidget spec: aSpecSelector layoutFrame: aLayoutFrame

	^ self new
		subwidget: subwidget 
		spec: aSpecSelector 
		layoutFrame:  aLayoutFrame;
		yourself! !

!SpecLayoutAddWithSpec methodsFor: 'instance creation' stamp: 'StephaneDucasse 12/27/2012 18:38'!
generateArguments
	
	self arguments: {{subwidget .#layout:. layoutFrame asArray}}.! !

!SpecLayoutAddWithSpec methodsFor: 'instance creation' stamp: 'StephaneDucasse 12/27/2012 22:40'!
subwidget: sub spec: aSpecSelector layoutFrame: aFrameLayout

	self subwidget: (sub isArray 
						ifTrue: [ #(model), sub , {aSpecSelector} ]
						ifFalse: [ {#model. sub . aSpecSelector } ]).
						
	self layoutFrame: aFrameLayout.
	self generateArguments! !

!SpecLayoutSend class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
selector: selector arguments: arguments

	^ self new
		arguments: arguments;
		selector: selector;
		yourself! !

!SpecLayoutSend methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
arguments
	
	^ arguments! !

!SpecLayoutSend methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
arguments: anObject
	
	arguments := anObject! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/18/2012 05:07'!
asSpecElements

	^ {self selector.}, self arguments! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
bottomFraction

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
bottomFraction: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
bottomOffset

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
bottomOffset: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/31/2012 15:52'!
isSplitter

	^ false! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
leftFraction

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
leftFraction: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
leftOffset

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
leftOffset: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
rightFraction

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
rightFraction: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
rightOffset

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
rightOffset: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
selector
	
	^ selector! !

!SpecLayoutSend methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 04:49'!
selector: anObject
	
	selector := anObject! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
topFraction

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
topFraction: aNumber

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:09'!
topOffset

	^ 0! !

!SpecLayoutSend methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/31/2012 14:10'!
topOffset: aNumber

	^ 0! !

Object subclass: #SpecLayout
	instanceVariableNames: 'type commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecLayout commentStamp: '<historical>' prior: 0!
A SpecPresenter is a object used to describe a user interface!

SpecLayout subclass: #SpecColumnLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecColumnLayout commentStamp: '<historical>' prior: 0!
A SpecColumnLayout is the layout used to specify a new column!

!SpecColumnLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 05:43'!
add: aSpec height: aNumber
	
	self add: aSpec origin: 0@0 corner: 1@1 offsetOrigin: 0@0 offsetCorner: 0@aNumber ! !

!SpecColumnLayout methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 7/31/2012 15:10'!
addSplitter

	self commands add: (SpecSplitterHorizontal commands: self commands)! !

!SpecColumnLayout methodsFor: 'converting' stamp: 'StephaneDucasse 12/27/2012 22:39'!
asArray
	| size result currentOffset  numberOfProportionals currentProportional delta lastFractionIndex height |
	self flag: #toFix. "This method is a giant: strange name, huge logic"
	currentOffset := 0.
	currentProportional := 0.
	result := OrderedCollection new.
	result add: self type.
	size := self commands size.
	numberOfProportionals := 0.
	lastFractionIndex := 0.
	self commands do: [:e |
		e layoutFrame hasNoOffsets
			ifTrue: [ numberOfProportionals := numberOfProportionals +1 ]].
	
	numberOfProportionals isZero
		ifTrue: [ delta := 0 ]
		ifFalse: [ delta := 1/numberOfProportionals ].
	
	self commands doWithIndex: [:e :idx |
		e layoutFrame hasNoOffsets
			ifTrue: [ "fractions"
				e layoutFrame:  ((0@currentProportional corner: 1@(currentProportional +delta)) asLayoutFrame topOffset: currentOffset ).
				currentOffset := 0.
				currentProportional := currentProportional + delta.
				lastFractionIndex := idx ]
			ifFalse: [ "offsets"
				height := e bottomOffset - e topOffset.
				idx = size
					ifTrue: [
						e layoutFrame: ((0@1 corner: 1@1) asLayoutFrame
													 topLeftOffset: e leftOffset @ height negated;
													 bottomRightOffset:  e rightOffset@0)]
					ifFalse: [
						e layoutFrame: ((0@currentProportional corner: 1@currentProportional) asLayoutFrame
									topLeftOffset: e leftOffset@currentOffset ; 
									bottomRightOffset:  e rightOffset@ (currentOffset + height)).
						currentOffset := (currentOffset + height) ]]].
			
	(lastFractionIndex > 0 and: [ lastFractionIndex < size ])
		ifTrue: [ | index ante |
			index := size - 1.
			[ index > lastFractionIndex ] whileTrue: [ | myHeight |
				ante := self commands at: index.
				index := index -1.
				myHeight := ante bottomOffset - ante topOffset.
				ante 
					topOffset: (height+myHeight) negated; 
					bottomOffset: height negated.
				height := height+myHeight ].
			
			self assert: (index = lastFractionIndex).
			ante := self commands at: index.
			ante bottomOffset: height negated ].		
			
	(self commands reject: [:e | e isSplitter ]) do: [:e |
		| left right bottom top windowBorderWidth |
		windowBorderWidth := self class windowBorderWidth.
		left := e leftOffset.
		right := e rightOffset.
		bottom := e bottomOffset.
		top := e topOffset.
		
		e rightFraction = 1 ifTrue: [ 
			right isZero 
				ifTrue: [ e rightOffset: windowBorderWidth negated ]
				ifFalse: [ e rightOffset: right - ProportionalSplitterMorph splitterWidth ]].
		e leftFraction = 0
			ifTrue: [ 
				left isZero 
					ifTrue: [ e leftOffset: windowBorderWidth ]
					ifFalse: [ e leftOffset: left + ProportionalSplitterMorph splitterWidth ]]
			ifFalse: [ e leftFraction = 1 ifFalse: [
						e leftOffset: left + ProportionalSplitterMorph splitterWidth]].

		e bottomFraction = 1 ifTrue: [ 
			bottom isZero
				ifTrue: [ e bottomOffset: windowBorderWidth negated ]
				ifFalse: [ e bottomOffset: bottom - ProportionalSplitterMorph splitterWidth ]].
		e topFraction = 0
			ifTrue: [ 
				top isZero 
					ifTrue: [ e topOffset: windowBorderWidth ]
					ifFalse: [ e topOffset: top + ProportionalSplitterMorph splitterWidth ]]
			ifFalse: [ e topFraction = 1 ifFalse: [
						e topOffset: top + ProportionalSplitterMorph splitterWidth]].
		
		e generateArguments.
		e asSpecElements do: [:el |
			result add: el ]].
	
	(self commands select: [:e | e isSplitter ]) do: [:e |
		e generateArguments.
			e asSpecElements do: [:el |
				result add: el ]].
		
	result add: #checkSplitters.
	
	^ result asArray! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:44'!
abstract

	^self new 
		type: #AbstractSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:44'!
button

	^self new
		type: #ButtonSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:44'!
checkbox

	^self new 
		type: #CheckboxSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
composed

	^self new
		type: #ComposableSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/12/2012 18:57'!
dialogWindow

	^self new 
		type: #DialogWindowSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
droplist

	^self new 
		type: #DropListSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
iconlist

	^self new 
		type: #IconListSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
label

	^self new
		type: #LabelSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:45'!
list

	^self new 
		type: #List;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
multicolumnlist

	^self new 
		type: #MultiColumnListSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
raw

	^self new 
		type: #RawSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/12/2012 18:57'!
slider

	^self new 
		type: #SliderSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
text

	^self new 
		type: #TextSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
textfield 

	^self new 
		type: #TextFieldSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/18/2012 12:46'!
tree

	^self new 
		type: #TreeSpec;
		yourself! !

!SpecLayout class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/12/2012 18:57'!
window

	^self new 
		type: #WindowSpec;
		yourself! !

!SpecLayout class methodsFor: 'constants' stamp: 'BenjaminVanRyseghem 7/18/2012 18:49'!
windowBorderWidth

	^ 0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: aSpec 
	
	self add: aSpec origin: 0@0 corner: 1@1! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: aSpec origin: originPoint corner: cornerPoint 

	self add: aSpec origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecLayout methodsFor: 'commands' stamp: 'StephaneDucasse 12/24/2012 17:27'!
add: aSpec origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint
	
	commands add: (SpecLayoutAdd 
							subwidget: aSpec
							layoutFrame: 
								((originPoint corner: cornerPoint) asLayoutFrame 
									topLeftOffset: ooPoint;
									bottomRightOffset: ocPoint ))! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: modelGetter withSpec: aSymbol 
	
	self add: modelGetter withSpec: aSymbol origin: 0@0 corner: 1@1! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
add: modelGetter withSpec: aSymbol origin: originPoint corner: cornerPoint 

	self add: modelGetter withSpec: aSymbol origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecLayout methodsFor: 'commands' stamp: 'StephaneDucasse 12/27/2012 18:33'!
add: modelGetter withSpec: aSymbol origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint

	commands add: (SpecLayoutAddWithSpec 
							subwidget: modelGetter 
							spec: aSymbol 
							layoutFrame: ((originPoint corner: cornerPoint) asLayoutFrame 
												topLeftOffset: ooPoint;
												bottomRightOffset: ocPoint))! !

!SpecLayout methodsFor: 'converting' stamp: 'StephaneDucasse 12/27/2012 22:37'!
asArray

	| result |
	result := OrderedCollection new.
	result add: self type.
				
	self commands do: [:e |
		e asSpecElements do: [:el | result add: el ]].
		
	^result asArray! !

!SpecLayout methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
commands
	^ commands! !

!SpecLayout methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
commands: anObject
	commands := anObject! !

!SpecLayout methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
initialize 
	super initialize.
	
	type := #ComposableSpec.
	self commands: OrderedCollection new.! !

!SpecLayout methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
isSpecLayout

	^ true! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newColumn: aBlock 
	
	self newColumn: aBlock origin: 0@0 corner: 1@1! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newColumn: aBlock origin: originPoint corner: cornerPoint 

	self newColumn: aBlock origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecLayout methodsFor: 'commands' stamp: 'StephaneDucasse 12/27/2012 17:50'!
newColumn: aBlock origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint
	
	commands add: (SpecLayoutAddColumn
							block: aBlock
							layoutFrame: ((originPoint corner: cornerPoint) asLayoutFrame
												 topLeftOffset: ooPoint;
												bottomRightOffset: ocPoint)).! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 7/9/2012 13:40'!
newColumn: aBlock  width: aNumber
	
	self newColumn: aBlock  origin: 0@0 corner: 0@1 offsetOrigin: 0@0 offsetCorner: aNumber @0! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newRow: aBlock 
	
	self newRow: aBlock origin: 0@0 corner: 1@1! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 7/9/2012 17:05'!
newRow: aBlock height: aNumber
	
	self newRow: aBlock  origin: 0@0 corner: 1@0 offsetOrigin: 0@0 offsetCorner: 0@aNumber ! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
newRow: aBlock origin: originPoint corner: cornerPoint 

	self newRow: aBlock origin: originPoint corner: cornerPoint offsetOrigin: 0@0 offsetCorner: 0@0! !

!SpecLayout methodsFor: 'commands' stamp: 'StephaneDucasse 12/27/2012 18:06'!
newRow: aBlock origin: originPoint corner: cornerPoint offsetOrigin: ooPoint offsetCorner: ocPoint
	
	commands add: (SpecLayoutAddRow
							block: aBlock
							layoutFrame: ((originPoint corner: cornerPoint) asLayoutFrame 
										topLeftOffset: ooPoint;
										bottomRightOffset: ocPoint)).! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
send: aSelector
	
	self send: aSelector withArguments: #()! !

!SpecLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
send: aSelector withArguments: arguments


	self commands add: (SpecLayoutSend
							selector: aSelector
							arguments: arguments).! !

!SpecLayout methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
type
	^ type! !

!SpecLayout methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/18/2012 06:40'!
type: anObject
	type := anObject! !

SpecLayout subclass: #SpecRowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Layout'!

!SpecRowLayout commentStamp: '<historical>' prior: 0!
A SpecRowLayout isthe layout used to specify a new row!

!SpecRowLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 6/18/2012 06:33'!
add: aSpec width: aNumber
	
	self add: aSpec origin: 0@0 corner: 1@1 offsetOrigin: 0@0 offsetCorner: aNumber @0! !

!SpecRowLayout methodsFor: 'commands' stamp: 'BenjaminVanRyseghem 7/31/2012 16:09'!
addSplitter

	self commands add: (SpecSplitterVertical commands: self commands)! !

!SpecRowLayout methodsFor: 'converting' stamp: 'StephaneDucasse 12/27/2012 22:36'!
asArray
	| result currentOffset  numberOfProportionals currentProportional delta size lastFractionIndex width |
	currentOffset := 0.
	currentProportional := 0.
	result := OrderedCollection new.
	result add: self type.
	numberOfProportionals := 0.
	lastFractionIndex := 0.
	size := self commands size.
	
	self commands do: [:e |
		e layoutFrame hasNoOffsets 
			ifTrue: [ numberOfProportionals := numberOfProportionals +1 ]].
	
	numberOfProportionals isZero
		ifTrue: [ delta := 0 ]
		ifFalse: [ delta := 1/numberOfProportionals ].
	
	self commands doWithIndex: [:e :idx |
		e layoutFrame hasNoOffsets 
			ifTrue: [
				e layoutFrame: ((currentProportional@0 corner: (currentProportional +delta)@1) asLayoutFrame leftOffset: currentOffset). 
				currentOffset := 0.
				currentProportional := currentProportional +delta.
				lastFractionIndex := idx ]
			ifFalse: [| y0 y1 |
				width := e offsets width.
				y0 := e offsets top.
				y1 := e offsets bottom.
				idx = size 
					ifTrue: [
						e layoutFrame: ((1@0 corner: 1@1) asLayoutFrame 
												topLeftOffset: width negated @y0;
												bottomRightOffset:  0@y1)]
					ifFalse: [
						e layoutFrame: ((currentProportional@0 corner: currentProportional@1) asLayoutFrame
							topLeftOffset: currentOffset@y0 ; 
							bottomRightOffset: (currentOffset + width)@y1).
						currentOffset := (currentOffset + width) ]]].
	
	(lastFractionIndex > 0 and: [ lastFractionIndex < size ])
		ifTrue: [ | index ante |
			index := size-1.
			[ index > lastFractionIndex ] whileTrue: [ | myWidth |
				ante := self commands at: index.
				index := index -1.
				myWidth := ante rightOffset - ante leftOffset.
				ante
					leftOffset: (width+myWidth) negated;
					rightOffset: width negated.
				width := width+myWidth ].
			self assert: (index = lastFractionIndex).
			ante := self commands at: index.
			ante layoutFrame rightOffset: width negated ].		
			
	(self commands reject: [:e | e isSplitter ]) do: [:e |
		| left right bottom top windowBorderWidth |
		windowBorderWidth := self class windowBorderWidth.
		left := e leftOffset.
		right := e rightOffset.

		bottom := e bottomOffset.
		top := e topOffset.
		
		e rightFraction = 1 ifTrue: [ 
			right isZero 
				ifTrue: [ e rightOffset: windowBorderWidth negated ]
				ifFalse: [ e rightOffset: right - ProportionalSplitterMorph splitterWidth ]].
		e leftFraction = 0
			ifTrue: [ 
				left isZero 
					ifTrue: [ e leftOffset: windowBorderWidth ]
					ifFalse: [ e leftOffset: left+ ProportionalSplitterMorph splitterWidth ]]
			ifFalse: [ e leftFraction = 1 ifFalse: [
						e leftOffset: left + ProportionalSplitterMorph splitterWidth]].

		e bottomFraction = 1 ifTrue: [ 
			bottom isZero
				ifTrue: [ e bottomOffset: windowBorderWidth negated ]
				ifFalse: [ e bottomOffset: bottom - ProportionalSplitterMorph splitterWidth ]].
		e topFraction = 0
			ifTrue: [ 
				top isZero 
					ifTrue: [ e topOffset: windowBorderWidth ]
					ifFalse: [ e topOffset: top + ProportionalSplitterMorph splitterWidth ]]
			ifFalse: [ e topFraction = 1 ifFalse: [
						e topOffset: top + ProportionalSplitterMorph splitterWidth]].
		e generateArguments.
		e asSpecElements do: [:el |
			result add: el ]].
	
	(self commands select: [:e | e isSplitter ]) do: [:e |
		e generateArguments.
		e asSpecElements do: [:el |
			result add: el ]].
	
	result add: #checkSplitters.
	
	^ result asArray! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 18:08'!
checkSplitters
	| size |
	
	size := submorphs size.
	(self submorphsSatisfying: [:e | e isKindOf: ProportionalSplitterMorph ]) do: [:e || index idx |
		index := submorphs identityIndexOf: e.
		idx := index + 1.
		"above"
		[ idx <= size and: [ ((submorphs at: idx) isKindOf: ProportionalSplitterMorph) not ]] whileTrue: [
			e addLeftOrTop: (submorphs at: idx).
			idx := idx +1 ].
		
		idx := index - 1.
		
		"below"
		[ idx > 0 and: [ ((submorphs at: idx) isKindOf: ProportionalSplitterMorph) not ]] whileTrue: [
			e addRightOrBottom: (submorphs at: idx).
			idx := idx -1 ]]! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 15:47'!
newHSplitter

	^ ProportionalSplitterMorph new
			beSplitsTopAndBottom;
			setProperty: #model toValue: self.! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'IgorStasenko 12/19/2012 18:00'!
newHSplitterAt: anIndex

	| above frame splitter index size |
	size := submorphs size.
	index := size - anIndex + 2.
	above := self submorphs at: index.
	frame := above layoutFrame.
	splitter := self newHSplitter.
	splitter  layoutFrame:  ((frame leftFraction @ frame bottomFraction corner: frame rightFraction @ frame bottomFraction) asLayoutFrame 
										bottomOffset: 4).			
	self privateAddMorph: splitter atIndex: (size - anIndex + 2)! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'BenjaminVanRyseghem 7/31/2012 15:47'!
newVSplitter

	^ ProportionalSplitterMorph new
			setProperty: #model toValue: self.! !

!PanelMorph methodsFor: '*Spec-Layout' stamp: 'IgorStasenko 12/19/2012 18:01'!
newVSplitterAt: anIndex
	| left frame splitter index size |

	size := submorphs size.
	index := size - anIndex + 2.
	left := self submorphs at: index.
	frame := left layoutFrame.
	
	splitter := self newVSplitter.
	splitter 
		layoutFrame: ((frame rightFraction @ frame topFraction corner: frame rightFraction @ frame bottomFraction) asLayoutFrame
							 rightOffset: 4).

	self privateAddMorph: splitter atIndex: (size - anIndex + 2)! !
